<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey H.M. Taylor}
 * @copyright Onpub (TM). Copyright 2009, Onpubco.
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 */
class OnpubLogin
{
  private $pdoDatabase;
  private $pdoHost;
  private $pdoUser;
  private $pdoPassword;
  private $logout;
  private $target;
  private $rememberLogin;
  private $exception;

  function __construct($pdoDatabase = "", $pdoHost = "localhost", $pdoUser = "",
    $pdoPassword = "", $logout = FALSE, $target = NULL, $rememberLogin = FALSE,
    $exception = NULL)
  {
    $this->pdoDatabase = trim($pdoDatabase);
    $this->pdoHost = trim($pdoHost);
    $this->pdoUser = trim($pdoUser);
    $this->pdoPassword = trim($pdoPassword);
    $this->logout = $logout;
    $this->target = $target;
    $this->rememberLogin = $rememberLogin;
    $this->exception = $exception;
  }

  public function display()
  {
    en ('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">');
    en ('<html>');
    en ('<head>');
    en ('<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">');
    en ('<meta http-equiv="Content-Style-Type" content="text/css">');
    en ('<title>Onpub (on ' . $_SERVER['SERVER_NAME'] . ')</title>');
    en ('<link rel="stylesheet" type="text/css" href="gui/css/yui/reset-fonts-grids.css">');
    en ('<link rel="stylesheet" type="text/css" href="gui/css/yui/base-min.css">');
    en ('<link rel="stylesheet" type="text/css" href="gui/css/onpub.css">');
    en ('</head>');
    en ('<body>');

    en ('<div id="doc2">');
    en ('<div id="hd"><!-- header --></div>');
    en ('<div id="bd">');

    en ('<div id="yui-main">');
    en ('<div class="yui-b">');

    en ('<div class="yui-gb"> <!-- the "special grid" -->');
    en ('<div class="yui-u first">&nbsp;</div>');

    en ('<div class="yui-u">');

    en(
      '<a href="index.php"><img src="gui/images/onpub.png" width="93" height="35" alt="Onpub" title="Onpub" border="0"></a>',
      1, 2);

    en ('<form action="index.php" method="post">');
    en ('<div>');

    if ($this->pdoDatabase === NULL)
    {
      en ('<b>Database</b><br>');
      en ('<input type="text" maxlength="255" size="25" name="pdoDatabase" value=""> <img src="gui/icons/exclamation.png" align="top" alt="Required field" title="Required field">');
    }
    else
    {
      en ('<b>Database</b><br>');
      en ('<input type="text" maxlength="255" size="25" name="pdoDatabase" value="'
        . htmlentities($this->pdoDatabase) . '">');
    }

    if (defined('ONPUBGUI_PDO_HOST'))
    {
      en ('<input type="hidden" name="pdoHost" value="' . ONPUBGUI_PDO_HOST
        . '">');
    }
    else
    {
      br (2);
      en ('<b>Host</b><br>');
      en ('<input type="text" maxlength="255" size="25" name="pdoHost" value="'
        . htmlentities($this->pdoHost) . '">');
    }

    br (2);
    en ('<b>Username</b><br>');
    en ('<input type="text" maxlength="255" size="25" name="pdoUser" value="'
      . htmlentities($this->pdoUser) . '">');

    br (2);
    en ('<b>Password</b><br>');
    en ('<input type="password" maxlength="255" size="25" name="pdoPassword" value="">');

    br (2);
    en ('<input type="submit" value="Login">');

    if ($this->exception)
    {
      en ('<br><br><span class="error">' . $this->exception->getMessage()
        . '</span>');
    }

    if ($this->target)
    {
      $newTarget = "";

      if (is_array($this->target))
      {
        $keys = array_keys($this->target);

        for ($i = 0; $i < sizeof($keys); $i++)
        {
          $newTarget .= $keys[$i] . "=" . $this->target[$keys[$i]];

          if (($i + 1) != sizeof($keys))
          {
            $newTarget .= "&";
          }
        }

        $this->target = $newTarget;
      }

      en ('<input type="hidden" name="target" value="' . $this->target . '">');
    }

    en ('<input type="hidden" name="onpub" value="LoginProcess">');

    en ('</div>');
    en ('</form>');

    en ('</div>');

    en ('<div class="yui-u">&nbsp;</div>');
    en ('</div>');

    en ('</div>');
    en ('</div>');

    en ('</div>');
    //en( '<div id="ft"><!-- footer --></div>' );
    en ('</div>');

    en ('</body>');
    en ('</html>');
  }

  public function validate()
  {
    if (!$this->pdoDatabase)
    {
      $this->pdoDatabase = NULL;
      return FALSE;
    }

    try
    {
      $pdo = new PDO("mysql:host=" . $this->pdoHost
        . ";dbname=$this->pdoDatabase", $this->pdoUser, $this->pdoPassword);
    }
    catch (PDOException $e)
    {
      throw $e;
    }

    $pdo = NULL;
    return TRUE;
  }

  public function process()
  {
    if ($this->logout)
    {
      $_SESSION = array ();

      if (isset($_COOKIE[session_name()]))
      {
        setcookie(session_name(), "", (time() - 42000), "/");
      }

      session_destroy();
    }

    session_regenerate_id();

    $_SESSION['PDO_HOST'] = $this->pdoHost;
    $_SESSION['PDO_USER'] = $this->pdoUser;
    $_SESSION['PDO_PASSWORD'] = $this->pdoPassword;
    $_SESSION['PDO_DATABASE'] = $this->pdoDatabase;
  }

  public function getTarget() { return $this->target; }

  public function setException($exception) { $this->exception = $exception; }
}
?>