<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey H.M. Taylor}
 * @copyright Onpub (TM). Copyright 2009, Onpubco.
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 */
class OnpubMoveArticles
{
  private $pdo;
  private $IDs;
  private $sectionIDs;

  function __construct(PDO $pdo, $IDs, $sectionIDs = array ())
  {
    $this->pdo = $pdo;
    $this->IDs = $IDs;
    $this->sectionIDs = $sectionIDs;
  }

  public function display()
  {
    $oarticles = new OnpubArticles($this->pdo);
    $osections = new OnpubSections($this->pdo);
    $owebsites = new OnpubWebsites($this->pdo);
    $articles = array ();
    $websites = array ();

    try
    {
      if (is_array($this->IDs))
      {
        $queryOptions = new OnpubQueryOptions();
        $queryOptions->includeContent = FALSE;

        for ($i = 0; $i < sizeof($this->IDs); $i++)
        {
          $articles[] = $oarticles->get($this->IDs[$i], $queryOptions);
        }
      }

      $queryOptions = new OnpubQueryOptions();
      $queryOptions->orderBy = "name";
      $queryOptions->order = "ASC";
      $websites = $owebsites->select($queryOptions);
    }
    catch (PDOException $e)
    {
      throw $e;
    }

    $widget = new OnpubWidgetHeader("Move Articles");
    $widget->display();

    en ('<form action="index.php" method="post">');

    en ('<div class="no-table">');

    if (sizeof($articles))
    {
      if (sizeof($articles) > 1)
      {
        en ('<b>Selected Articles</b>');
      }
      else
      {
        en ('<b>Selected Article</b>');
      }

      br();

      for ($i = 0; $i < sizeof($articles); $i++)
      {
        en ('<a href="index.php?onpub=ViewArticle&amp;ID=' . $articles[$i]->ID
          . '" title="View">' . $articles[$i]->title . '</a><br>');
        en ('<div><input type="hidden" name="IDs[]" value="' . $articles[$i]->ID
          . '"></div>');
      }

      br();

      $widget = new OnpubWidgetSections();
      $widget->websites = $websites;
      $widget->osections = $osections;
      $widget->display();

      en ('<a href="javascript:submitForm();"><img src="'
        . ONPUBGUI_IMAGE_DIRECTORY
          . 'save.png" width="60" height="25" border="0" alt="Save" title="Save"></a>');
    }
    else
    {
      en ('<span class="error">No articles were selected to move.</span>');
    }

    en ('</div>');

    en ('<div><input type="hidden" name="onpub" value="ArticleMoveProcess"></div>');

    en ('</form>');

    $widget = new OnpubWidgetFooter();
    $widget->display();
  }

  public function validate() { }

  public function process()
  {
    $oarticles = new OnpubArticles($this->pdo);
    $queryOptions = new OnpubQueryOptions();
    $queryOptions->includeAuthors = TRUE;

    try
    {
      for ($i = 0; $i < sizeof($this->IDs); $i++)
      {
        $article = $oarticles->get($this->IDs[$i], $queryOptions);
        $article->sectionIDs = $this->sectionIDs;
        $oarticles->update($article);
      }
    }
    catch (PDOException $e)
    {
      throw $e;
    }
  }
}
?>