<?php

/**
 * @author {@link mailto:corey@onpubco.com Corey H.M. Taylor}
 * @copyright Onpub (TM). Copyright 2009, Onpubco.
 * {@link http://onpubco.com/}
 * @license http://www.gnu.org/copyleft/gpl.html GNU General Public License
 * Version 2
 * @package onpubgui
 */
class OnpubTidy
{
  function __construct() { }

  public static function getDefaultOptions()
  {
    // See: http://tidy.sourceforge.net/docs/quickref.html
    // And: http://php.net/manual/en/ref.tidy.php
    $tidyConfig = array ();

    // HTML, XHTML, XML Options
    $tidyConfig['add-xml-decl'] = FALSE;
    $tidyConfig['add-xml-space'] = FALSE;
    $tidyConfig['alt-text'] = FALSE;
    $tidyConfig['assume-xml-procins'] = FALSE;
    $tidyConfig['bare'] = TRUE;
    $tidyConfig['clean'] = TRUE;
    $tidyConfig['css-prefix'] = "";
    $tidyConfig['decorate-inferred-ul'] = FALSE;
    $tidyConfig['doctype'] = "omit";
    $tidyConfig['drop-empty-paras'] = TRUE;
    $tidyConfig['drop-font-tags'] = FALSE;
    $tidyConfig['drop-proprietary-attributes'] = FALSE;
    $tidyConfig['enclose-block-text'] = TRUE;
    $tidyConfig['enclose-text'] = FALSE;
    $tidyConfig['escape-cdata'] = FALSE;
    $tidyConfig['fix-backslash'] = TRUE;
    $tidyConfig['fix-bad-comments'] = TRUE;
    $tidyConfig['fix-uri'] = TRUE;
    $tidyConfig['hide-comments'] = FALSE;
    $tidyConfig['hide-endtags'] = FALSE;
    $tidyConfig['indent-cdata'] = TRUE;
    $tidyConfig['input-xml'] = FALSE;
    $tidyConfig['join-classes'] = FALSE;
    $tidyConfig['join-styles'] = TRUE;
    $tidyConfig['literal-attributes'] = FALSE;
    $tidyConfig['logical-emphasis'] = TRUE;
    $tidyConfig['lower-literals'] = TRUE;
    $tidyConfig['merge-divs'] = FALSE;
    $tidyConfig['ncr'] = TRUE;
    $tidyConfig['new-blocklevel-tags'] = "";
    $tidyConfig['new-empty-tags'] = "";
    $tidyConfig['new-inline-tags'] = "";
    $tidyConfig['new-pre-tags'] = "";
    $tidyConfig['numeric-entities'] = FALSE;
    $tidyConfig['output-html'] = FALSE;
    $tidyConfig['output-xhtml'] = TRUE;
    $tidyConfig['output-xml'] = FALSE;
    $tidyConfig['preserve-entities'] = TRUE;
    $tidyConfig['quote-ampersand'] = TRUE;
    $tidyConfig['quote-marks'] = FALSE;
    $tidyConfig['quote-nbsp'] = TRUE;
    $tidyConfig['repeated-attributes'] = "keep-last";
    $tidyConfig['replace-color'] = FALSE;
    $tidyConfig['show-body-only'] = TRUE;
    $tidyConfig['uppercase-attributes'] = FALSE;
    $tidyConfig['uppercase-tags'] = FALSE;
    $tidyConfig['word-2000'] = TRUE;

    // Diagnostics Options
    $tidyConfig['accessibility-check'] = 0;
    $tidyConfig['show-errors'] = 6;
    $tidyConfig['show-warnings'] = TRUE;

    // Pretty Print Options
    $tidyConfig['break-before-br'] = TRUE;
    $tidyConfig['indent'] = TRUE;
    $tidyConfig['indent-attributes'] = FALSE;
    $tidyConfig['indent-spaces'] = "2";
    $tidyConfig['markup'] = FALSE;
    $tidyConfig['punctuation-wrap'] = FALSE;
    $tidyConfig['split'] = FALSE;
    $tidyConfig['tab-size'] = "8";
    $tidyConfig['vertical-space'] = FALSE;
    $tidyConfig['wrap'] = 80;
    $tidyConfig['wrap-asp'] = FALSE;
    $tidyConfig['wrap-attributes'] = FALSE;
    $tidyConfig['wrap-jste'] = FALSE;
    $tidyConfig['wrap-php'] = FALSE;
    $tidyConfig['wrap-script-literals'] = FALSE;
    $tidyConfig['wrap-sections'] = FALSE;

    // Character Encoding Options
    $tidyConfig['ascii-chars'] = FALSE;
    $tidyConfig['char-encoding'] = "latin1";
    $tidyConfig['input-encoding'] = "latin1";
    $tidyConfig['language'] = "";
    $tidyConfig['newline'] = "";
    $tidyConfig['output-bom'] = FALSE;
    $tidyConfig['output-encoding'] = "latin1";

    return $tidyConfig;
  }
}